<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import { computed, onMounted, reactive, ref, watch } from "vue";
import { Modal, Toast } from "bootstrap";
import { partial } from "filesize";
import { useS3ObjectStore } from "@/stores/s3objects";
import BootstrapToast from "@/components/BootstrapToast.vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";

const fsize = partial({ base: 2, standard: "jedec" });
const objectRepository = useS3ObjectStore();

const props = defineProps<{
  modalId: string;
  bucketName: string;
  keyPrefix: string;
  editObjectFileName?: string;
}>();

const randomIDSuffix = Math.random().toString(16).substring(2, 8);
const objectFileInput = ref<HTMLInputElement | undefined>(undefined);
let uploadModal: Modal | null = null;
let successToast: Toast | null = null;
let errorToast: Toast | null = null;

const currentFolders = computed<string[]>(() => props.keyPrefix.split("/"));

watch(
  () => props.editObjectFileName,
  (nextFileName) => {
    formState.key = nextFileName ?? "";
    resetForm();
    formState.uploadDirectory = nextFileName == undefined;
  },
);

const formState = reactive<{
  files?: FileList;
  key: string;
  err: string;
  uploadDirectory: boolean;
}>({
  files: undefined,
  key: "",
  err: "",
  uploadDirectory: false,
});

const uploadProgressState = reactive<{
  uploading: boolean;
  totalFiles: number;
  totalFileSize: number;
  uploadedBytes: number;
  currentFile: string;
  controller?: AbortController;
  uploadedFiles: Set<string>;
  errorFiles: Set<string>;
}>({
  uploading: false,
  totalFiles: 0,
  totalFileSize: 0,
  uploadedBytes: 0,
  currentFile: "",
  controller: undefined,
  uploadedFiles: new Set<string>(),
  errorFiles: new Set<string>(),
});

const processedFiles = computed<number>(
  () =>
    uploadProgressState.uploadedFiles.size +
    uploadProgressState.errorFiles.size,
);

const uploadProgress = computed<number>(() =>
  Math.round(
    (100 * uploadProgressState.uploadedBytes) /
      uploadProgressState.totalFileSize,
  ),
);

const editObject = computed<boolean>(
  () => props.editObjectFileName !== undefined,
);

async function uploadFile(file: UploadFileType) {
  uploadProgressState.uploadedBytes = 0;
  uploadProgressState.totalFileSize = file.file.size;
  await objectRepository.uploadObjectFile(
    file.bucket,
    file.key,
    file.file,
    (progress) => {
      if (progress.loaded != null) {
        uploadProgressState.uploadedBytes = progress.loaded;
      }
      if (progress.total != null) {
        uploadProgressState.totalFileSize = progress.total;
      }
    },
    file.abortController,
  );
}

async function uploadObjects() {
  if (formState.files == undefined || formState.files.length === 0) {
    return;
  }
  uploadProgressState.uploading = true;
  uploadProgressState.controller = new AbortController();
  try {
    if (formState.files.length === 1) {
      const key =
        props.keyPrefix.length > 0
          ? props.keyPrefix + "/" + formState.key
          : formState.key;
      await uploadFile({
        file: formState.files[0],
        key: key,
        bucket: props.bucketName,
        abortController: uploadProgressState.controller,
      });
      formState.key = "";
    } else {
      uploadProgressState.totalFiles = formState.files.length;
      uploadProgressState.errorFiles = new Set<string>();
      uploadProgressState.uploadedFiles = new Set<string>();
      for (let index = 0; index < formState.files.length; index++) {
        const file = formState.files[index];
        const key = computeKey(formState.files[index]);
        uploadProgressState.currentFile = key;
        try {
          await uploadFile({
            file: file,
            key: key,
            bucket: props.bucketName,
            abortController: uploadProgressState.controller,
          });
          uploadProgressState.uploadedFiles.add(key);
          // eslint-disable-next-line @typescript-eslint/ban-ts-comment
          // @ts-ignore
        } catch (err: Error) {
          uploadProgressState.errorFiles.add(key);
          if (err.name === "AbortError") {
            break;
          }
        }
      }
    }
    uploadModal?.hide();
    successToast?.show();
    if (objectFileInput.value != undefined) {
      objectFileInput.value.value = "";
    }
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore
  } catch (err: Error) {
    formState.err = err.name;
    errorToast?.show();
  } finally {
    uploadProgressState.uploading = false;
    uploadProgressState.controller = undefined;
  }
}

type UploadFileType = {
  file: File;
  key: string;
  bucket: string;
  abortController?: AbortController;
};

function fileChange() {
  if (objectFileInput.value != undefined) {
    formState.files = objectFileInput.value.files!;
    if (!editObject.value && formState.files?.length === 1) {
      formState.key = formState.files[0].name;
    }
  }
}

function computeKey(file: File) {
  return (
    (props.keyPrefix.length > 0 ? props.keyPrefix + "/" : "") +
    (file.webkitRelativePath.length > 0 ? file.webkitRelativePath : file.name)
  );
}

function abortUpload() {
  uploadProgressState.controller?.abort();
}

function determineIcon(key: string): string {
  if (uploadProgressState.errorFiles.has(key)) {
    return "circle-xmark";
  }
  if (uploadProgressState.uploadedFiles.has(key)) {
    return "circle-check";
  }
  if (uploadProgressState.currentFile === key) {
    return "circle-up";
  }
  return "circle-pause";
}

function determineColor(key: string): string {
  if (uploadProgressState.errorFiles.has(key)) {
    return "text-danger";
  }
  if (uploadProgressState.uploadedFiles.has(key)) {
    return "text-success";
  }
  if (uploadProgressState.currentFile === key) {
    return "text-info";
  }
  return "text-warning";
}

function resetForm() {
  uploadProgressState.uploading = false;
  uploadProgressState.totalFiles = 0;
  uploadProgressState.totalFileSize = 0;
  uploadProgressState.uploadedBytes = 0;
  uploadProgressState.currentFile = "";
  uploadProgressState.controller = undefined;
  uploadProgressState.uploadedFiles = new Set<string>();
  uploadProgressState.errorFiles = new Set<string>();
  objectFileInput.value = undefined;
}

onMounted(() => {
  uploadModal = new Modal("#" + props.modalId);
  successToast = new Toast("#successToast-" + randomIDSuffix);
  errorToast = new Toast("#errorToast-" + randomIDSuffix);
});
</script>

<template>
  <bootstrap-toast :toast-id="'successToast-' + randomIDSuffix">
    Successfully uploaded files
  </bootstrap-toast>
  <bootstrap-toast
    :toast-id="'errorToast-' + randomIDSuffix"
    color-class="danger"
  >
    There has been some Error.<br />
    Code: {{ formState.err }}
  </bootstrap-toast>
  <bootstrap-modal
    :modal-id="modalId"
    :static-backdrop="true"
    modal-label="Upload Object Modal"
    size-modifier-modal="xl"
    v-on="{ 'hidden.bs.modal': abortUpload }"
  >
    <template #header>
      <h4>Upload file to</h4>
      <ol class="breadcrumb">
        <li class="breadcrumb-item">{{ props.bucketName }}</li>
        <li
          v-for="folder in currentFolders"
          :key="folder"
          class="breadcrumb-item"
        >
          {{ folder }}
        </li>
      </ol>
    </template>
    <template #body>
      <div class="container-fluid">
        <p>{{ formState.err }}</p>
        <div class="row">
          <div class="col-7">
            <template v-if="editObjectFileName == undefined">
              <h6>Upload</h6>
              <div class="btn-group mb-2" role="group">
                <input
                  :id="`upload-file-radio-${randomIDSuffix}`"
                  v-model="formState.uploadDirectory"
                  type="radio"
                  :value="false"
                  class="btn-check"
                  :name="`directory-radio-${randomIDSuffix}`"
                />
                <label
                  class="btn btn-outline-primary"
                  :for="`upload-file-radio-${randomIDSuffix}`"
                  >Files</label
                >

                <input
                  :id="`upload-directory-radio-${randomIDSuffix}`"
                  v-model="formState.uploadDirectory"
                  type="radio"
                  :value="true"
                  class="btn-check"
                  :name="`directory-radio-${randomIDSuffix}`"
                />
                <label
                  class="btn btn-outline-primary"
                  :for="`upload-directory-radio-${randomIDSuffix}`"
                  >Directory</label
                >
              </div>
            </template>
            <form
              :id="'uploadObjectForm' + randomIDSuffix"
              @submit.prevent="uploadObjects"
            >
              <div class="mb-3">
                <label
                  v-if="editObject"
                  :for="'objectFile' + randomIDSuffix"
                  class="form-label"
                >
                  New File Content *
                </label>
                <label
                  v-else
                  :for="'objectFile' + randomIDSuffix"
                  class="form-label"
                >
                  File(s)
                </label>
                <input
                  :id="'objectFile' + randomIDSuffix"
                  ref="objectFileInput"
                  class="form-control"
                  type="file"
                  required
                  :webkitdirectory="formState.uploadDirectory"
                  :multiple="!editObject"
                  @change="fileChange"
                />
              </div>
              <div
                v-if="
                  (formState.files?.length ?? 0) < 2 ||
                  editObjectFileName != undefined
                "
                class="mb-3"
              >
                <label :for="'objectKey' + randomIDSuffix" class="form-label"
                  >Filename</label
                >
                <input
                  :id="'objectKey' + randomIDSuffix"
                  v-model="formState.key"
                  type="text"
                  :class="{
                    'form-control-plaintext': editObject,
                    'form-control': !editObject,
                  }"
                  required
                  :disabled="editObject"
                />
              </div>
              <div v-else-if="formState.files != undefined">
                <div v-if="uploadProgressState.uploading">
                  <p>
                    Uploading
                    {{ uploadProgressState.currentFile }}
                  </p>
                  <div
                    class="progress mt-2"
                    role="progressbar"
                    aria-label="Example with label"
                    :aria-valuenow="
                      Math.ceil(
                        (processedFiles * 100) / uploadProgressState.totalFiles,
                      )
                    "
                    aria-valuemin="0"
                    aria-valuemax="100"
                  >
                    <div
                      class="progress-bar"
                      :style="{
                        width: `${(processedFiles * 100) / uploadProgressState.totalFiles}%`,
                      }"
                    >
                      {{ processedFiles }} /
                      {{ uploadProgressState.totalFiles }}
                    </div>
                  </div>
                </div>
                <div class="overflow-auto" style="max-height: 60vh">
                  <div
                    v-for="index in formState.files.length"
                    :key="formState.files[index - 1].name"
                  >
                    <font-awesome-icon
                      :icon="`fa-solid fa-${determineIcon(computeKey(formState.files[index - 1]))}`"
                      :class="
                        determineColor(computeKey(formState.files[index - 1]))
                      "
                    />
                    {{
                      formState.files[index - 1].webkitRelativePath.length > 0
                        ? formState.files[index - 1].webkitRelativePath
                        : formState.files[index - 1].name
                    }}
                  </div>
                </div>
              </div>
            </form>
          </div>
          <div class="col-5">
            <p>
              Note: Delimiters ('/') are allowed in the file name to place the
              new file into a folder that will be created when the file is
              uploaded (to any depth of folders).
            </p>
            <p v-if="uploadProgressState.uploading" class="text-warning">
              <font-awesome-icon
                icon="fa-solid fa-triangle-exclamation"
                class="me-2"
              />
              Do not close the modal during the upload
            </p>
          </div>
        </div>
      </div>
    </template>
    <template #footer>
      <div
        v-if="
          uploadProgressState.uploading &&
          uploadProgressState.totalFileSize > 5242880
        "
        class="w-50 me-auto"
      >
        <div
          class="progress"
          aria-valuemin="0"
          aria-valuemax="100"
          role="progressbar"
          :aria-valuenow="uploadProgress"
          aria-label="Upload Progressbar"
        >
          <div
            class="progress-bar bg-info"
            :style="{ width: uploadProgress + '%' }"
          >
            {{ uploadProgress }}%
          </div>
        </div>
        <span>
          {{ fsize(uploadProgressState.uploadedBytes) }} /
          {{ fsize(uploadProgressState.totalFileSize) }}
        </span>
      </div>
      <button
        v-if="!uploadProgressState.uploading"
        type="button"
        class="btn btn-secondary"
        data-bs-dismiss="modal"
      >
        Close
      </button>
      <button
        v-if="uploadProgressState.uploading"
        type="button"
        class="btn btn-danger"
        @click="abortUpload"
      >
        Cancel
      </button>
      <button
        v-else
        type="submit"
        :form="'uploadObjectForm' + randomIDSuffix"
        class="btn btn-primary"
      >
        Upload
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
